package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.UserObject;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class UserObjectSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<UserObject> selectCond;
	private JSONObject customsearchval;
	public UserObjectSearchFilter(){
		this.page =new Page<UserObject>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<UserObject>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_userobjectname_like;

	public void setN_userobjectname_like(String n_userobjectname_like) {
        this.n_userobjectname_like = n_userobjectname_like;
        if(!StringUtils.isEmpty(this.n_userobjectname_like)){
            this.selectCond.like("userobjectname", n_userobjectname_like);
        }
    }
	private String n_userobjecttype_eq;

	public void setN_userobjecttype_eq(String n_userobjecttype_eq) {
        this.n_userobjecttype_eq = n_userobjecttype_eq;
        if(!StringUtils.isEmpty(this.n_userobjecttype_eq)){
            this.selectCond.eq("userobjecttype", n_userobjecttype_eq);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("userobjectname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}